---
title: PushEvent
slug: Web/API/PushEvent
tags:
  - API
  - ExtendableEvent
  - Interface
  - Offline
  - Push
  - Push API
  - Reference
  - Service Workers
  - Workers
---
<p>{{APIRef("Push API")}}{{SeeCompatTable()}}</p>

<p>The <strong><code>PushEvent</code></strong> interface of the <a href="/en-US/docs/Web/API/Push_API">Push API</a> represents a push message that has been received. This event is sent to the <a href="/en-US/docs/Web/API/ServiceWorkerGlobalScope">global scope</a> of a {{domxref("ServiceWorker")}}. It contains the information sent from an application server to a {{domxref("PushSubscription")}}.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("PushEvent.PushEvent()")}}</dt>
 <dd>Creates a new <code>PushEvent</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{domxref("ExtendableEvent")}}. Additional properties:</em></p>

<dl>
 <dt>{{domxref("PushEvent.data")}} {{readonlyinline}}</dt>
 <dd>Returns a reference to a {{domxref("PushMessageData")}} object containing data sent to the <span>{{domxref("PushSubscription")}}.</span></dd>
</dl>

<p><strong style="font-size: 2.14285714285714rem; font-weight: 700; letter-spacing: -1px; line-height: 30px;">Methods</strong></p>

<p><em>Inherits methods from its parent, {{domxref("ExtendableEvent")}}</em>.</p>

<h2 id="Examples">Examples</h2>

<p>The following example takes data from a <code>PushEvent</code> and displays it on all of the service worker's clients.</p>

<pre class="brush: js">self.addEventListener('push', function(event) {
  if (!(self.Notification &amp;&amp; self.Notification.permission === 'granted')) {
    return;
  }

  var data = {};
  if (event.data) {
    data = event.data.json();
  }
  var title = data.title || "Something Has Happened";
  var message = data.message || "Here's something you might want to check out.";
  var icon = "images/new-notification.png";

  var notification = new self.Notification(title, {
    body: message,
    tag: 'simple-push-demo-notification',
    icon: icon
  });

  notification.addEventListener('click', function() {
    if (clients.openWindow) {
      clients.openWindow('https://example.blog.com/2015/03/04/something-new.html');
    }
  });
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Push API','#pushevent-interface','PushEvent')}}</td>
   <td>{{Spec2('Push API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.PushEvent")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Push_API">Push API</a></li>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API</a></li>
</ul>
